package com.example.android.clouddb;
import android.content.Context;
import android.net.Uri;
import android.os.Bundle;
import android.support.v4.app.Fragment;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.Button;
import android.widget.CheckBox;
import android.widget.EditText;
import android.widget.ListView;

import java.util.HashMap;


public class AddForm extends Fragment {

    private Button submitButton;
    private MainActivity appActivity;
    private EditText newItemName;
    private EditText newItemDescription;
    private ListView ingredientDisplay;
    private HashMap<String, Integer> ingredients;
    private MapAdapter ingredientAdapter;
    private Button plusIngredient;
    private EditText ingredientAmount;
    private EditText ingredientName;
    private CheckBox boolVegetarian;


    public AddForm() {
    }

    public static AddForm newInstance() {
        AddForm fragment = new AddForm();
        return fragment;
    }

    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
    }

    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container,
                             Bundle savedInstanceState) {
        // Inflate the layout for this fragment
        View view = inflater.inflate(R.layout.fragment_edit_recipe, container, false);
        indentifyLayoutComponents(view);
        appActivity = (MainActivity) getActivity();


        ingredients = new HashMap<String, Integer>();
        ingredientAdapter = new MapAdapter<String, Integer>(this.getContext(), ingredients);
        ingredientDisplay.setAdapter(ingredientAdapter);

        plusIngredient.setOnClickListener(new View.OnClickListener() {

            @Override
            public void onClick(View view) {
                saveIngredient();
                clearIngredientForm();
            }
        });

        // Submit recipe handled here
        addSubmitOnClickListener(submitButton);
        return view;
    }

    public void saveIngredient() {
        String key = ingredientName.getText().toString();
        int value = Integer.valueOf(ingredientAmount.getText().toString());
        ingredients.put(key, value);
        ingredientAdapter.notifyDataSetChanged();

    }

    public void clearIngredientForm(){
        ingredientAmount.setText("");
        ingredientName.setText("");
    }

    // Look up layout components and save references to global vars
    public void indentifyLayoutComponents(View view) {
        boolVegetarian = (CheckBox) view.findViewById(R.id.is_vegetarian);
        ingredientName = (EditText) view.findViewById(R.id.ingredient_name_entry);
        plusIngredient = (Button) view.findViewById(R.id.add_ingredient_trigger);
        ingredientDisplay = (ListView) view.findViewById(R.id.show_ingredient_list);
        newItemName = (EditText) view.findViewById(R.id.item_name);
        newItemDescription = (EditText) view.findViewById(R.id.item_description);
        submitButton = (Button) view.findViewById(R.id.action_save_recipe);
        ingredientDisplay = (ListView) view.findViewById(R.id.show_ingredient_list);
        ingredientAmount = (EditText) view.findViewById(R.id.ingredient_amount_entry);
    }

    public void addSubmitOnClickListener(Button button) {
        button.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                String recipeName = newItemName.getText().toString();
                String description = newItemDescription.getText().toString();
                Boolean isVegetarian = boolVegetarian.isChecked();
                Recipe recipe = new Recipe(recipeName, description, ingredients, isVegetarian);

                appActivity.getDatabase().replaceRecipe(recipe, recipe);
                getFragmentManager().popBackStackImmediate();

            }
        });

    }
}
