package com.example.android.clouddb;

import android.content.Context;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.TextView;

import java.util.Map;


public class MapAdapter<K, V> extends BaseAdapter {

    private Context context;
    private Map dataSet;

    public MapAdapter(Context context, Map<K, V> dataSet) {
        this.context = context;
        this.dataSet = dataSet;
    }


    @Override
    public int getCount() {
        return dataSet.size();
    }

    @Override
    public Object getItem(int position) {
        int i = 0;
        for (Object entry : dataSet.entrySet()) {
            if (i++ == position) return entry;
        }
        return null;
    }

    @Override
    public long getItemId(int i) {
        return 0;
    }

    @Override
    public View getView(int position, View convertView, ViewGroup parent) {

        if (convertView == null) {
            convertView = LayoutInflater.from(context)
                    .inflate(R.layout.map_layout, parent, false);
        }

        TextView ingredientView = (TextView) convertView.findViewById(R.id.text1);
        TextView amountView = (TextView) convertView.findViewById(R.id.text2);

        Object item = getItem(position);
        ingredientView.setText(item.toString());
        amountView.setText(item.toString());

        return convertView;
    }
    // https://stackoverflow.com/questions/19466757/hashmap-to-listview?noredirect=1&lq=1

}