package com.example.android.clouddb;

import android.content.Context;
import android.os.Bundle;
import android.support.v4.app.Fragment;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.Button;
import android.widget.EditText;
import android.widget.LinearLayout;

import java.util.ArrayList;
import java.util.HashMap;


public class QueryForm extends Fragment {

    private EditText queryKey;
    private Button querySubmit;
    private MainActivity appActivity;
    private DBDisplay dbDisplayFragment;
    private String queryKeyInput = "";

    public QueryForm() {
        // Required empty public constructor
    }

    public static QueryForm newInstance(String param1, String param2) {
        QueryForm fragment = new QueryForm();
          return fragment;
    }

    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        appActivity = (MainActivity) getActivity();
        DBHandler db = appActivity.getDatabase();
        dbDisplayFragment = DBDisplay.newInstance(db);
        appActivity.replaceFragment(dbDisplayFragment, R.id.query_results_frame);
    }

    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container,
                             Bundle savedInstanceState) {
        View view = inflater.inflate(R.layout.fragment_query_form, container, false);


        identifyLayoutPieces(view);
        querySubmit.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                queryKeyInput = queryKey.getText().toString();

                if (queryKeyInput.isEmpty()) {
                    dbDisplayFragment.clearDisplay();
                }
                else {
                    dbDisplayFragment.getRecipesForKeyword(queryKeyInput);
                }
                queryKey.setText("");
            }

        });
        queryKey.performClick();
        return view;
    }


    public void identifyLayoutPieces(View view){
        queryKey = (EditText) view.findViewById(R.id.search_key);
        querySubmit = (Button) view.findViewById(R.id.action_search);
    }

    @Override
    public void onResume() {
        super.onResume();
    }

    @Override
    public void onAttach(Context context) {
        super.onAttach(context);
      }

    @Override
    public void onDetach() {
        super.onDetach();
    }


}
