package com.example.android.clouddb;


import android.content.SharedPreferences;
import android.os.Bundle;
import android.support.v7.preference.PreferenceFragmentCompat;

import java.util.Map;



public class SettingsFragment extends PreferenceFragmentCompat implements SharedPreferences.OnSharedPreferenceChangeListener {

    private DBHandler dbHandler;
    private MainActivity appActivity;


    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        appActivity = (MainActivity) getActivity();
        dbHandler = appActivity.getDatabase();
    }

    @Override
    public void onCreatePreferences(Bundle bundle, String s) {
        // Load the Preferences from the XML file
        addPreferencesFromResource(R.xml.preferences);
    }


    public void onSharedPreferenceChanged(SharedPreferences sharedPreferences, String key) {
        Map userPreferences = dbHandler.getUserPreferences();
        // If local value does not match cloud value, overwrite cloud value
        if ((Boolean) userPreferences.get(key.toString()) != (Boolean) sharedPreferences.getBoolean(key.toString(), false)) {
            dbHandler.setUserPreferences(sharedPreferences.getAll());
        }
    }


    @Override
    public void onResume() {
        super.onResume();
        getPreferenceScreen().getSharedPreferences().registerOnSharedPreferenceChangeListener(this);
    }

    @Override
    public void onPause() {
        super.onPause();
        getPreferenceScreen().getSharedPreferences().unregisterOnSharedPreferenceChangeListener(this);
    }


}
